package com.huimv.production.datasource.dao.repo;

import com.huimv.production.datasource.dao.entity.TDeliveryEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface TDeliveryRepo extends JpaRepository<TDeliveryEntity, String>, JpaSpecificationExecutor<TDeliveryEntity> {
   
    /**
     * @Method      : getPsy
     * @Description : Psy
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 13:50
     */
    @Query(nativeQuery = true,value = "SELECT CAST " +
            "( " +
            "PJWCHZ * chl * NCWS AS DEC ( 8, 2 )) AS 'PSY'  " +
            "FROM " +
            "( " +
            "SELECT " +
            " CAST " +
            "( " +
            " (AVG " +
            "( TNewStru7743.FamountLiveInt* 1.0 )) AS DEC ( 8, 2 )) AS 'PJWCHZ'  " +
            "FROM " +
            "TDelivery " +
            "LEFT JOIN TNewStru7743 ON TNewStru7743.FDeliveryMainStruID= TDelivery.FID  " +
            "WHERE " +
            "TDelivery.FLogStatee IN ( 3, 4, 6 )  " +
            "AND ( datediff( dd,  ?1, TDelivery.FDATEDELIVERY ) >= 0 )  " +
            "AND ( datediff( dd,  ?2, TDelivery.FDATEDELIVERY ) <= 0 )  " +
            "and (TDelivery.hogpenDID in( ?3)) " +
            ") PJWCHZ, " +
            "( " +
            "SELECT " +
            "CASE " +
            "WHEN " +
            "zczc = 0 THEN " +
            "0 ELSE 1-sw / zczc  " +
            "END AS 'chl'  " +
            "FROM " +
            "( " +
            "SELECT COUNT " +
            "( TBornNewStru.Fid ) AS 'zczc'  " +
            "FROM " +
            "TBorn " +
            "LEFT JOIN TBornNewStru ON TBornNewStru.FBornMainStruID = TBorn.FID  " +
            "WHERE " +
            "TBorn.FLOGSTATEE IN ( 3, 4, 6 )  " +
            "AND ( datediff( dd,  ?1, TBorn.FDATEBORN ) >= 0 )  " +
            "AND ( datediff( dd,  ?2, TBorn.FDATEBORN ) <= 0 ) " +
            "and TBorn.HOGPENDID in ( ?3)  " +
            ") cs, " +
            "( " +
            "SELECT SUM " +
            "( " +
            "isnull( TPigDieChild.FweakpigdieCount, 0 )) + SUM ( " +
            "isnull( TPigDieChild.Fpigdiecount, 0 )) AS sw  " +
            "FROM " +
            "TPigDie " +
            "LEFT JOIN TPigDieChild ON TPigDieChild.FPigDieMainStruID= TPigDie.FID  " +
            "WHERE " +
            "TPigDie.FBillState IN ( 3, 4, 6 )  " +
            "AND TPigDieChild.FPigSex IN ( 1, 2, 3 )  " +
            "AND FPIGSTATE = 15  " +
            "AND ( TPigDie.FDieDate BETWEEN  ?1 AND  ?2 ) " +
            "and (TPigdie.PIGHOUSEID in ( ?3)) " +
            ") sw  " +
            ") chl, " +
            "( " +
            "SELECT  " +
            " " +
            "CAST " +
            "( " +
            "(365/(RSQ+BRQ+dpjj+dnsts+hbpzjj)) AS DEC ( 8, 2 )) AS NCWS " +
            " FROM ( " +
            "select 母猪日均存栏 as mucl ,hbsl as hbcl,case  when ts is null then 250 else ts end as tss,RSQ AS RSQ ,BRQ AS BRQ,isnull(CAST " +
            "( " +
            "(1.0*dpjjh)/(1.0*母猪日均存栏) AS DEC ( 8, 2 )),0) as dpjj " +
            ", isnull(CAST " +
            "( " +
            "(1.0*ztjgtss)/(1.0*母猪日均存栏) AS DEC ( 8, 2 )),0) as dnsts , " +
            " " +
            "isnull(CAST " +
            "(((case  when ts is null then 250 else ts end-250)*hbsl/母猪日均存栏) as DEC ( 8, 2 ) ),0) as hbpzjj " +
            "from ( " +
            "select  " +
            "isnull(mzrjcl.RJAmount,0) as '母猪日均存栏' " +
            "from( " +
            "select tmp_tbl.ZCID, AVG(tmp_tbl.FAmount) 'RJAmount' from (select tppa.HogpendID 'ZCID' " +
            "           ,tppa.FDay 'FDate',SUM(tppa.FAmount) 'FAmount' from TPigStateAmountForBoar tppa where 1=1  " +
            "        and tppa.FDay>= ?1 " +
            "           and tppa.FDay<= ?2 and FPigClass=2 " +
            "              and tppa.HogpendID in( ?3) " +
            "           group by tppa.HogpendID,tppa.FDay) tmp_tbl group by tmp_tbl.ZCID )mzrjcl)mzcl, " +
            "            " +
            "           (SELECT   " +
            "count(sow.fnumber) as 'hbsl' " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "left join TPigArchives as sow on TNewStru8094.SOWSTRID= sow.FID   " +
            "WHERE TBreeding.FlogStateE in (3,4,6)  " +
            "And (TBreeding.HOGPENDID in( ?3))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            "   and (TNewStru8094.fuponPigStateE =11) " +
            "   )hbs, " +
            "   (select avg(hb.ts) as 'ts' from(SELECT TOrganizeCell.FNAME  as '所在猪场', TPigHouse.FName as '所在猪舍',  " +
            "       TBreeding.FDATEBREED as '配种日期', TNewStru8094.fuponPigStateE as '状态', " +
            " CAST(DATEDIFF(dd,(select top 1 FDATEOFBIRTH from TPigArchives where fnumber=sow.fnumber),TBreeding.FDATEBREED) AS DECIMAL(10,2)) as 'ts' " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "left join TPigHouse on TBreeding.PIGHOUSEDID = TPigHouse.FID   " +
            "left join TPigArchives as sow on TNewStru8094.SOWSTRID= sow.FID   " +
            "left join TPigArchives as boar on  TNewStru8094.BOARONESTRID = boar.FID   " +
            "left join TPigArchives as boar1 on TNewStru8094.boarTwoIntID = boar1.FID  " +
            "LEFT JOIN TBreed ON boar.varietyDID = TBreed.FID  " +
            "left join TEmployee on TEmployee.FID=TNewStru8094.EMPONEBOARDID " +
            "left join TEmployee emp on emp.FID = TNewStru8094.EMPTWOBOARDID " +
            "WHERE TBreeding.FlogStateE in (3,4,6) and TNewStru8094.fuponPigStateE=11 " +
            "And (TBreeding.HOGPENDID in(''))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            ")hb)hbts, " +
            "(select sum(zh.本次配种至上窝断奶天数) as 'dpjjh' from( SELECT TOrganizeCell.FNAME  as '所在猪场', " +
            "datediff(day, (select max(TWeaning.FDateWeaning) from TWeaning left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID  " +
            "where TWeaning.FlogStateE in (3,4,6) and TWeaningNewStru.SOWSTRID=TNewStru8094.SOWSTRID  " +
            "and TWeaningNewStru.FParityInt=TNewStru8094.FParityInt), TBreeding.FDateBreed) as '本次配种至上窝断奶天数'  " +
            "FROM TNewStru8094 " +
            "left join TBreeding on TNewStru8094.FBreedingMainStruID = TBreeding.FID   " +
            "left join TOrganizeCell on TBreeding.HOGPENDID = TOrganizeCell.FID   " +
            "WHERE TBreeding.FlogStateE in (3,4,6)  " +
            "And (TBreeding.HOGPENDID in( ?3))  " +
            "And (TBreeding.FDATEBREED>= ?1 or  ?1 is null)  " +
            "And (TBreeding.FDATEBREED<= ?2 or  ?2 is null)  " +
            "group by TOrganizeCell.FNAME,TNewStru8094.SOWSTRID,TNewStru8094.FPARITYINT,TBreeding.FDATEBREED)zh)zhs " +
            ", " +
            "( select sum(zh.ztjgts) as 'ztjgtss' from (SELECT  DATEDIFF(dd,TDL.ztbgrq , max(TDL.rq)) as 'ztjgts' " +
            "  from(   " +
            "  SELECT  " +
            "  TPigArchives.FNUMBER as 'zzbh',     " +
            "  TPigdie.FDIEDATE as 'rq', " +
            "case    " +
            "  when TPigdieChild.FPIGSTATE = 3 then (select MAX(TWeaning.FDATEWEANING)  from TWeaning ,TWeaningNewStru  " +
            "  where TWeaning.FDATEWEANING <=TPigdie.FDIEDATE  " +
            "  and TWeaning.FID = TWeaningNewStru.FWeaningMainStruID " +
            "  and TWeaningNewStru.SOWSTRID = TPigdieChild.NUMBERID " +
            "   )    end as 'ztbgrq'  " +
            "  FROM TPigdie  " +
            "  left join TPigdieChild on TPigdie.FID=TPigdieChild.FPigdieMainStruID  " +
            "  left join TPigArchives on TPigdieChild.NUMBERID = TPigArchives.FID  " +
            "  WHERE TPigdie.Fbillstate in(3,4,6)  " +
            "  AND (TPigdie.PIGHOUSEID in( ?3)) " +
            "And ( datediff(dd, ?1,TPigdie.FDIEDATE)>=0 or  ?1 is null)  " +
            "And (datediff(dd, ?2,TPigdie.FDIEDATE)<=0 or  ?2 is null)  " +
            "  AND (TPigdieChild.FPIGSEX =2)  " +
            "  AND (TPigdieChild.FPIGSTATE =3)  " +
            "  union all  " +
            "  SELECT   " +
            "  TPigArchives.FNumber as 'zzbh',   " +
            "  TPigLose.FPIGLOSEDATE as 'rq', " +
            "case   " +
            "  when TPigLoseChild.FPIGSTATE = 3 then (select MAX(TWeaning.FDATEWEANING)  from TWeaning ,TWeaningNewStru  " +
            "  where TWeaning.FDATEWEANING <=TPigLose.FPIGLOSEDATE  " +
            "  and TWeaning.FID = TWeaningNewStru.FWeaningMainStruID " +
            "  and TWeaningNewStru.SOWSTRID = TPigLoseChild.NUMBERID " +
            "   )  end as 'ztbgrq'  " +
            "  FROM TPigLose  " +
            "  left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID = TPigLose.FID  " +
            "  left join TPigArchives on TPigLoseChild.NUMBERID  = TPigArchives.FID " +
            "  WHERE TPigLose.Fbillstate in(3,4,6)  " +
            "   AND (TPigLose.PIGHOUSEID in( ?3)) " +
            "  And ( datediff(dd, ?1,TPigLose.FPIGLOSEDATE)>=0 or  ?1 is null)  " +
            "And (datediff(dd, ?2,TPigLose.FPIGLOSEDATE)<=0 or  ?2 is null)  " +
            "  AND (TPigLoseChild.FSEX =2)  " +
            "  AND (TPigLoseChild.FPIGSTATE =3) ) TDL   " +
            "  GROUP BY   TDL.zzbh , TDL.ztbgrq)zh)dnst,(select  avg(DATEDIFF(day,TNewStru7743.FDATEBREED,TDelivery.FDATEDELIVERY)) as 'RSQ' " +
            "from TDelivery  " +
            "left join TNewStru7743 on TNewStru7743.FDeliveryMainStruID=TDelivery.FID  " +
            " where FLogStatee in(3,4,6) and isnull(FPREGNANTDAYINT,0)>0 " +
            "and (TDelivery.hogpendID in( ?3)) and TDelivery.FDateDelivery between  ?1 and  ?2)TRSQ " +
            ",(select avg(isnull(TWeaningNewStru.FDAYAGE,0)) as 'BRQ'  from TWeaning  " +
            "left join TWeaningNewStru on TWeaningNewStru.FWeaningMainStruID=TWeaning.FID where FLogStatee in(3,4,6)  " +
            "and isnull(TWeaningNewStru.FDAYAGE,0)>0 " +
            "and (TWeaning.hogpendID in( ?3))     " +
            "and TWeaning.FdateWeaning between  ?1 and  ?2)TBTQ)ZZ " +
            ") ncws")
    List<Object[]> getPsy(String startDate,String endDate,String farmID);

    /**
     * @Method      : getReEstrusRate
     * @Description : 返情率
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15
     * @Time        : 13:50
     */

    @Query(nativeQuery = true,value =
            "SELECT " +
                    "(select TOrganizeCell.FNAME from TOrganizeCell where FID in ( tmp_tblpz.HogpendID)) AS '猪场',    " +
                    "CAST (  " +
                    "COUNT ( tmp_tblfm.SowStrID ) * 1.0 /  " +
                    "( CASE SUM ( tmp_tblpz.配种次数 ) WHEN 0 THEN NULL ELSE SUM ( tmp_tblpz.配种次数 ) END )  " +
                    "AS DEC ( 8, 5 ) " +
                    ") AS '配种返情率'  " +
                    "FROM " +
                    "( " +
                    "SELECT " +
                    "TBreeding.HogpendID,    " +
                    "TNewStru8094.FBreedD,     " +
                    "TNewStru8094.SowStrID,     " +
                    "TNewStru8094.FParityInt,      " +
                    "COUNT ( TNewStru8094.FID ) AS '配种次数'  " +
                    "FROM " +
                    "TBreeding   " +
                    "LEFT JOIN TNewStru8094    " +
                    "ON TNewStru8094.FBreedingMainStruID= TBreeding.FID    " +
                    "WHERE " +
                    "TBreeding.FLogStatee IN ( 3, 4, 6 )     " +
                    "AND datediff( dd,?1, FDateBreed ) >=- 121    " +
                    "AND datediff( dd,?2, FDateBreed ) <=- 121    " +
                    "AND ( " +
                    "TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))    " +
                    "GROUP BY " +
                    "TBreeding.HogpendID,    " +
                    "TNewStru8094.FBreedD,    " +
                    "TNewStru8094.SowStrID,     " +
                    "TNewStru8094.FParityInt     " +
                    ") tmp_tblpz " +
                    "LEFT JOIN ( " +
                    "SELECT " +
                    "TReturnEstrusewStru.SowStrID,    " +
                    "TReturnEstrusewStru.FParityInt    " +
                    "FROM " +
                    "TReturnEstrusewStru    " +
                    "LEFT JOIN TReturnEstrus  " +
                    "ON TReturnEstrusewStru.FReturnEstrusMainStruID= TReturnEstrus.FID   " +
                    "WHERE " +
                    "TReturnEstrus.FLogStatee IN ( 3, 4, 6 )     " +
                    "AND datediff( dd,?1, TReturnEstrusewStru.FDateBreed ) >=- 121    " +
                    "AND datediff( dd,?2, TReturnEstrusewStru.FDateBreed ) <=- 121    " +
                    "AND ( TReturnEstrus.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3))    " +
                    ") UNION ALL " +
                    "SELECT " +
                    "TNullPregnantNewStru.SowStrID,  " +
                    "TNullPregnantNewStru.FParityInt   " +
                    "FROM " +
                    "TNullPregnantNewStru   " +
                    "LEFT JOIN TNullPregnant  " +
                    "ON TNullPregnantNewStru.FNullPregnantMainStruID= TNullPregnant.FID  " +
                    "WHERE " +
                    "TNullPregnant.FLogStatee IN ( 3, 4, 6 )   " +
                    "AND datediff( dd,?1, TNullPregnantNewStru.FDateBreed ) >=- 121   " +
                    "AND datediff( dd,?2, TNullPregnantNewStru.FDateBreed ) <=- 121     " +
                    "AND ( TNullPregnant.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)) )    " +
                    ") tmp_tblfm ON tmp_tblpz.SowStrID= tmp_tblfm.SowStrID  " +
                    "AND tmp_tblpz.FParityInt= tmp_tblfm.FParityInt  " +
                    "GROUP BY " +
                    "tmp_tblpz.HogpendID ")
    List<Object[]> getReEstrusRate(String startDate,String endDate,String farmName);

    /**
     * @Method      : getParturitionRate
     * @Description : 分娩率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 14:43
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FSHORTNAME as 'farm', tmp_tblpz.FBreedD as 'variety', " +
            "CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.mate_times) when 0 then null else sum(tmp_tblpz.mate_times) end) as dec(8,5)) as 'parturition_rate' " +
            "from (select " +
            "TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as 'mate_times' " +
            "from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            "where TBreeding.FLogStatee in(3,4,6) and datediff(dd, ?1, FDateBreed)>=-121 and datediff(dd, ?2,FDateBreed) <=-121 " +
            "group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            ") tmp_tblpz " +
            "left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743 " +
            "left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID " +
            "where TDelivery.FLogStatee in(3,4,6)  and datediff(dd, ?1, TNewStru7743.FDateBreed )>=-121 " +
            "and datediff(dd, ?2,TNewStru7743.FDateBreed ) <=-121 " +
            ") tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            "left join TOrganizeCell on tmp_tblpz.HogpendID=TOrganizeCell.FID " +
            "where TOrganizeCell.FNAME is not null " +
            "group by TOrganizeCell.FSHORTNAME,tmp_tblpz.FBreedD")
    List<Object[]> getParturitionRate_old(String startDate, String endDate);

    @Query(nativeQuery = true,value ="SELECT " +
            "(select TOrganizeCell.FNAME from TOrganizeCell where FID in (  tmp_tblpz.HogpendID)) AS '猪场', " +
            "CAST ( " +
            "COUNT ( tmp_tblfm.SowStrID ) * 1.0 / ( CASE SUM ( tmp_tblpz.配种次数 ) WHEN 0 THEN NULL ELSE SUM ( tmp_tblpz.配种次数 ) END ) AS DEC ( 8, 5 )) AS '分娩率'  " +
            "FROM " +
            "( " +
            "SELECT " +
            "TBreeding.HogpendID, " +
            "TNewStru8094.FBreedD, " +
            "TNewStru8094.SowStrID, " +
            "TNewStru8094.FParityInt, " +
            "COUNT ( TNewStru8094.FID ) AS '配种次数'  " +
            "FROM " +
            "TBreeding " +
            "LEFT JOIN TNewStru8094 ON TNewStru8094.FBreedingMainStruID= TBreeding.FID  " +
            "WHERE " +
            "TBreeding.FLogStatee IN ( 3, 4, 6 )  " +
            "AND datediff( dd,?1, FDateBreed ) >=- 121  " +
            "AND datediff( dd,?2, FDateBreed ) <=- 121  " +
            "AND ( " +
            "TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))  " +
            "GROUP BY " +
            "TBreeding.HogpendID, " +
            "TNewStru8094.FBreedD, " +
            "TNewStru8094.SowStrID, " +
            "TNewStru8094.FParityInt  " +
            ") tmp_tblpz " +
            "LEFT JOIN ( " +
            "SELECT " +
            "TNewStru7743.SowStrID, " +
            "TNewStru7743.FParityInt  " +
            "FROM " +
            "TNewStru7743 " +
            "LEFT JOIN TDelivery ON TNewStru7743.FDeliveryMainStruID= TDelivery.FID  " +
            "WHERE " +
            "TDelivery.FLogStatee IN ( 3, 4, 6 )  " +
            "AND datediff( dd,?1, TNewStru7743.FDateBreed ) >=- 121  " +
            "AND datediff( dd,?2, TNewStru7743.FDateBreed ) <=- 121  " +
            "AND ( TDelivery.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)) )  " +
            ") tmp_tblfm ON tmp_tblpz.SowStrID= tmp_tblfm.SowStrID  " +
            "AND tmp_tblpz.FParityInt= tmp_tblfm.FParityInt  " +
            "GROUP BY " +
            "tmp_tblpz.HogpendID ")
    List<Object[]> getParturitionRate(String startDate, String endDate,String farmName);
    
    /**
     * @Method      : getStorage
     * @Description : 各种存栏
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 14:57
     */
    @Query(nativeQuery = true,value ="SELECT oc.FSHORTNAME as 'farm',tb.FNAME as 'name',COUNT(tp.FID) as 'quantity' FROM (select TOrganizeCell.FID,TOrganizeCell.FSHORTNAME from  TOrganizeCell) oc RIGHT " +
            "JOIN TPigArchives tp ON tp.HOGPENWHEREDID = oc.FID  " +
            "RIGHT JOIN TBreed tb ON tb.FID = tp.VARIETYDID GROUP BY oc.FSHORTNAME,tb.FNAME ")
    List<Object[]> getStorage_old();

    @Query(nativeQuery = true,value ="select  " +
            "TOrganizeCell.FNAME as 猪场, " +
            "TBreed.FName as 'PZID',  " +
            "sum(FamountChangeInt) as 'ZZNUM'  " +
            "from TStockHistory  " +
            "left join TBreed on TStockHistory.breedDid=TBreed.FID  " +
            "left join TOrganizeCell on HogpendID=TOrganizeCell.FID  " +
            "where FpigClassE in(1,2)  and breedDid is not null and HogpendID in(select FID from TOrganizeCell where FNAME in (?1))  " +
            "group by TBreed.FName,TOrganizeCell.FNAME")
    List<Object[]> getStorage(String farmName);

    /**
     * @Method      : getPigletInfo
     * @Description : 均产仔数，仔猪存活率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 15:17
     */
    @Query(nativeQuery = true,value ="SELECT " +
            "( SELECT FSHORTNAME FROM dbo.TOrganizeCell WHERE FID = td.HOGPENDID ) AS 'farm'," +
            "COUNT ( tn.SOWSTRID ) AS 'birth_number', " +
            "SUM ( tn.FAMOUNTKITTENINT ) AS 'total', " +
            "ISNULL(tdie.csamount,0)+ISNULL(tlose.csamount,0) AS 'dead_quantity'  " +
            "FROM  " +
            "dbo.TDelivery td  " +
            "LEFT JOIN dbo.TNewStru7743 tn ON tn.FDeliveryMainStruID = td.FID  " +
            "LEFT JOIN (SELECT isnull(sum(isnull(FPIGDIECOUNT,0)+isnull(FWEAKPIGDIECOUNT,0)),0) as csamount,PIGHOUSEID FROM TPigdieChild,TPigdie WHERE  " +
            "FPigdieMainStruID = TPigdie.FID  " +
            "AND FDIEDATE BETWEEN ?1   " +
            "AND ?2  " +
            "and FPIGSEX = 3 AND FPIGSTATE = 15  " +
            "GROUP BY  " +
            "PIGHOUSEID ) tdie on tdie.PIGHOUSEID = td.HOGPENDID  " +
            "LEFT JOIN (SELECT isnull(ISNULL(sum(TPigLoseChild.FpigLoseCount),0)+ISNULL(sum(TPigLoseChild.FweakPigLoseCount),0),0) as csamount,PIGHOUSEID FROM TPigLoseChild,  " +
            "TPigLose  " +
            "WHERE  " +
            "FPigLoseMainStruID = TPigLose.FID  " +
            "AND FPIGLOSEDATE BETWEEN ?1  " +
            "AND ?2  " +
            "AND FSEX = 3  " +
            "AND FPIGSTATE = 15  " +
            "GROUP BY  " +
            "PIGHOUSEID ) tlose on tlose.PIGHOUSEID = td.HOGPENDID  " +
            "WHERE  " +
            "td.FLOGSTATEE IN ( 3, 4, 6 )   " +
            "AND datediff( dd, ?1, td.FDATEDELIVERY ) >= 0   " +
            "AND datediff( dd, ?2, td.FDATEDELIVERY ) <= 0  " +
            "GROUP BY td.HOGPENDID,tdie.csamount, tlose.csamount")
    List<Object[]> getPigletInfo_old(String startDate, String endDate);

    @Query(nativeQuery = true,value ="SELECT  " +
            "( SELECT FSHORTNAME FROM dbo.TOrganizeCell WHERE FID = td.HOGPENDID ) AS '猪场', " +
            "COUNT ( tn.SOWSTRID ) AS '分娩头数', " +
            "SUM ( tn.FAMOUNTKITTENINT ) AS '产仔总数', " +
            "ISNULL(tdie.csamount,0)+ISNULL(tlose.csamount,0) AS '仔猪死淘数' " +
            "FROM " +
            "dbo.TDelivery td " +
            "LEFT JOIN dbo.TNewStru7743 tn ON tn.FDeliveryMainStruID = td.FID  " +
            "LEFT JOIN (SELECT isnull(sum(isnull(FPIGDIECOUNT,0)+isnull(FWEAKPIGDIECOUNT,0)),0) as csamount,PIGHOUSEID FROM TPigdieChild,TPigdie WHERE " +
            "FPigdieMainStruID = TPigdie.FID  " +
            "AND FDIEDATE BETWEEN ?1  " +
            "AND ?2 " +
            "and FPIGSEX = 3 AND FPIGSTATE = 15 " +
            "GROUP BY " +
            "PIGHOUSEID ) tdie on tdie.PIGHOUSEID = td.HOGPENDID " +
            "LEFT JOIN (SELECT isnull(ISNULL(sum(TPigLoseChild.FpigLoseCount),0)+ISNULL(sum(TPigLoseChild.FweakPigLoseCount),0),0) as csamount,PIGHOUSEID FROM TPigLoseChild, " +
            "TPigLose  " +
            "WHERE " +
            "FPigLoseMainStruID = TPigLose.FID  " +
            "AND FPIGLOSEDATE BETWEEN ?1  " +
            "AND ?2  " +
            "AND FSEX = 3  " +
            "AND FPIGSTATE = 15 " +
            "GROUP BY " +
            "PIGHOUSEID ) tlose on tlose.PIGHOUSEID = td.HOGPENDID " +
            "WHERE " +
            "td.FLOGSTATEE IN ( 3, 4, 6 )  " +
            "AND datediff( dd, ?1, td.FDATEDELIVERY ) >= 0  " +
            "AND datediff( dd, ?2, td.FDATEDELIVERY ) <= 0  " +
            "AND td.HOGPENDID IN (select FID from TOrganizeCell where FNAME in (?3))  " +
            "GROUP BY " +
            "td.HOGPENDID, " +
            "tdie.csamount, " +
            "tlose.csamount")
    List<Object[]> getPigletInfo(String startDate, String endDate,String farmName);

    /**
     * @Method      : getMateQuantity
     * @Description : 配种数量
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 15:47
     */
    @Query(nativeQuery = true,value ="select TOrganizeCell.FSHORTNAME as 'farm', tmp_tblpzts.FBREEDD AS 'variety', sum(tmp_tblpzts.mate_times) as 'mate_quantity' from (select  " +
            "TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as 'mate_times'  " +
            "from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID  " +
            "where TBreeding.FLogStatee in(3,4,6)  and datediff(dd,?1, FDateBreed)>=0 and datediff(dd,?2,FDateBreed) <=0  " +
            "group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt  " +
            ") tmp_tblpzts  left join TOrganizeCell on tmp_tblpzts.HogpendID=TOrganizeCell.FID " +
            "where TOrganizeCell.FNAME is not null group by TOrganizeCell.FSHORTNAME,tmp_tblpzts.FBREEDD")
    List<Object[]> getMateQuantity_old(String startDate, String endDate);


    @Query(nativeQuery = true,value ="SELECT  " +
            "  (SELECT TOrganizeCell.FNAME FROM TOrganizeCell WHERE FID IN( tmp_tblpzts.HogpendID)) AS '猪场',  " +
            "  SUM ( tmp_tblpzts.配种次数 ) AS '配种头数'   " +
            " FROM  " +
            "  (  " +
            "  SELECT  " +
            "   TBreeding.HogpendID,  " +
            "   TNewStru8094.FBreedD,  " +
            "   TNewStru8094.SowStrID,  " +
            "   TNewStru8094.FParityInt,  " +
            "   COUNT ( TNewStru8094.FID ) AS '配种次数'   " +
            "  FROM  " +
            "   TBreeding  " +
            "   LEFT JOIN TNewStru8094 ON TNewStru8094.FBreedingMainStruID= TBreeding.FID   " +
            "  WHERE  " +
            "   TBreeding.FLogStatee IN ( 3, 4, 6 )   " +
            "   AND datediff( dd,?1, FDateBreed ) >= 0   " +
            "   AND datediff( dd,?2, FDateBreed ) <= 0   " +
            "   AND (  " +
            "   TBreeding.hogpenDID IN (select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  GROUP BY  " +
            "   TBreeding.HogpendID,  " +
            "   TNewStru8094.FBreedD,  " +
            "   TNewStru8094.SowStrID,  " +
            "   TNewStru8094.FParityInt   " +
            "  ) tmp_tblpzts   " +
            " GROUP BY  " +
            "  tmp_tblpzts.HogpendID ")
    List<Object[]> getMateQuantity(String startDate, String endDate,String farmName);

    /**
     * @Method      : getConceptionRate
     * @Description : 受胎率
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 16:15
     */
    @Query(nativeQuery = true,value =" select " +
            " TOrganizeCell.FshortName as '猪场', " +
            "  CAST((tmp_tblpz.fmts+isnull(tmp_tblpzlc.lcts,0))*1.0/tmp_tblpz.pzts*100 as dec(8,2)) as '受胎率' " +
            "  from " +
            "    (select tmp_tblpz.HogpendID as 'ZCID',sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fmts'," +
            "  CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML' " +
            "  from (select " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数' " +
            " from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2) " +
            " group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            " ) tmp_tblpz " +
            " left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743 " +
            "  left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID " +
            "  where TDelivery.FLogStatee in(3,4,6)  and TNewStru7743.FDateBreed>=DATEADD(DAY,-121,?1) and TNewStru7743.FDateBreed<=DATEADD(DAY,-121,?2)  " +
            "  ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            "  group by tmp_tblpz.HogpendID) tmp_tblpz  " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'lcts'," +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML' " +
            " from (select " +
            "  TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数' " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID " +
            " where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2) " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt " +
            "  ) tmp_tblpz " +
            "  left join (select TAbortionNewStru.SowStrID,TAbortionNewStru.FParityInt from TAbortionNewStru " +
            " left join TAbortion on TAbortionNewStru.FAbortionMainStruID=TAbortion.FID " +
            " where TAbortion.FLogStatee in(3,4,6)  and TAbortionNewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TAbortionNewStru.FDateBreed<=DATEADD(DAY,-121,?2)  " +
            " ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt " +
            " group by tmp_tblpz.HogpendID) tmp_tblpzlc on tmp_tblpzlc.ZCID=tmp_tblpz.ZCID " +
            " left join TOrganizeCell on tmp_tblpz.ZCID=TOrganizeCell.FID " +
            " where TOrganizeCell.FNAME in(?3)")
    List<Object[]> getConceptionRate(String startDate, String endDate,String farmName);

    @Query(nativeQuery = true,value =" select   " +
            "  TOrganizeCell.FshortName 'ZCNAME',  " +
            "  CAST((tmp_tblpz.fmts+isnull(tmp_tblpzlc.lcts,0))*1.0/tmp_tblpz.pzts*100 as dec(8,2)) as 受胎率  " +
            "   from  " +
            "    (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fmts',  " +
            "  CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            "  from (select   " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            " from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            " and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            " ) tmp_tblpz   " +
            " left join (select TNewStru7743.SowStrID,TNewStru7743.FParityInt from TNewStru7743   " +
            "  left join TDelivery on TNewStru7743.FDeliveryMainStruID=TDelivery.FID   " +
            "  where TDelivery.FLogStatee in(3,4,6)  and TNewStru7743.FDateBreed>=DATEADD(DAY,-121,?1) and TNewStru7743.FDateBreed<=DATEADD(DAY,-121,?2)  and (TDelivery.hogpenDID  in('EFB8649C-ED89-4174-A1E7-D6BA4B238992') )   " +
            "  ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            "  group by tmp_tblpz.HogpendID ) tmp_tblpz    " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'fqts',  " +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            " from (select   " +
            " TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            " where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            "  and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            "  ) tmp_tblpz   " +
            " left join (select TReturnEstrusewStru.SowStrID,TReturnEstrusewStru.FParityInt from TReturnEstrusewStru   " +
            " left join TReturnEstrus on TReturnEstrusewStru.FReturnEstrusMainStruID=TReturnEstrus.FID   " +
            " where TReturnEstrus.FLogStatee in(3,4,6)  and TReturnEstrusewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TReturnEstrusewStru.FDateBreed<=DATEADD(DAY,-121,?2)    " +
            "  and (TReturnEstrus.hogpenDID  in('EFB8649C-ED89-4174-A1E7-D6BA4B238992') )   " +
            ") tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            " group by tmp_tblpz.HogpendID ) tmp_tblpzfq on tmp_tblpzfq.ZCID=tmp_tblpz.ZCID  " +
            " left join (select tmp_tblpz.HogpendID as 'ZCID', sum(tmp_tblpz.配种次数) as 'PZTS', count(tmp_tblfm.SowStrID) as 'lcts',  " +
            " CAST(count(tmp_tblfm.SowStrID)*1.0/(case sum(tmp_tblpz.配种次数) when 0 then null else sum(tmp_tblpz.配种次数) end)*100 as dec(8,2)) as 'PZFML'   " +
            " from (select   " +
            "  TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt,count(TNewStru8094.FID) as '配种次数'   " +
            "  from TBreeding left join TNewStru8094 on TNewStru8094.FBreedingMainStruID=TBreeding.FID   " +
            "  where TBreeding.FLogStatee in(3,4,6)  and FDateBreed>=DATEADD(DAY,-121,?1) and FDateBreed<=DATEADD(DAY,-121,?2)   " +
            " and (TBreeding.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)))   " +
            "  group by TBreeding.HogpendID,TNewStru8094.FBreedD,TNewStru8094.SowStrID,TNewStru8094.FParityInt   " +
            "  ) tmp_tblpz   " +
            "  left join (select TAbortionNewStru.SowStrID,TAbortionNewStru.FParityInt from TAbortionNewStru   " +
            " left join TAbortion on TAbortionNewStru.FAbortionMainStruID=TAbortion.FID   " +
            "where TAbortion.FLogStatee in(3,4,6)  and TAbortionNewStru.FDateBreed>=DATEADD(DAY,-121,?1) and TAbortionNewStru.FDateBreed<=DATEADD(DAY,-121,?2)    " +
            "  and (TAbortion.hogpenDID  in(select FID from TOrganizeCell where FNAME in (?3)) )   " +
            " ) tmp_tblfm on tmp_tblpz.SowStrID=tmp_tblfm.SowStrID and tmp_tblpz.FParityInt=tmp_tblfm.FParityInt   " +
            "  group by tmp_tblpz.HogpendID ) tmp_tblpzlc on tmp_tblpzlc.ZCID=tmp_tblpz.ZCID  " +
            "   " +
            " left join TOrganizeCell on tmp_tblpz.ZCID=TOrganizeCell.FID")
    // --0.83
    List<Object[]> getConceptionRate_new(String startDate, String endDate,String farmName);


    /**
     * @Method      : getAllStorage
     * @Description : 总存栏，母猪存栏
     * @Params      : []
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 16:22
     */
    @Query(nativeQuery = true,value ="SELECT " +
            "H.FNAME AS 'farm', " +
            "mzcl AS 'sow_quantity', " +
            "gz + mzcl + jc + shbamount AS 'total'  " +
            "FROM (SELECT " +
            "TOrganizeCell.FID, " +
            "TOrganizeCell.FName  " +
            "FROM TOrganizeCell  " +
            "GROUP BY " +
            "TOrganizeCell.FName, " +
            "TOrganizeCell.FID  " +
            ") H RIGHT JOIN ( " +
            "SELECT " +
            "tblz_tmp.FNAME AS NAME, " +
            "isnull( SUM( tblz_tmp.gz ), 0 ) AS 'gz', " +
            "isnull( sum( tblz_tmp.mzcl ), 0 ) AS 'mzcl', " +
            "isnull( SUM( tblz_tmp.jc ), 0 ) AS 'jc', " +
            "isnull( SUM( tblz_tmp.shbamount ), 0 ) AS 'shbamount'  " +
            "FROM ( SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME', " +
            "CASE " +
            "WHEN TPigArchives.FPIGSTATEE IN ( 2, 11 )  " +
            "AND TPigArchives.FPigClassEnum = 1 THEN " +
            "COUNT( TPigArchives.FID )  " +
            "END AS 'gz', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 3, 4, 5, 6, 7, 10, 11, 12, 13 )  " +
            "AND TPigArchives.FPigClassEnum = 2 THEN " +
            "COUNT( TPigArchives.FID )  " +
            "END AS 'mzcl', " +
            "0 AS 'jc', " +
            "0 AS 'shbamount'  " +
            "FROM " +
            "TPigArchives  " +
            "WHERE " +
            "TPigArchives.FPigStatee IN ( 2, 3, 4, 5, 6, 7, 10, 11, 12, 13 )  " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID, " +
            "TPigArchives.FPIGSTATEE, " +
            "TPigArchives.FPigClassEnum UNION ALL " +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME', " +
            "0 AS 'gz', " +
            "0 AS 'mzcl', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 15, 14, 1, 21, 22, 16 ) THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 )  " +
            "END AS 'jc', " +
            "CASE " +
            "WHEN TPigArchives.FPigStatee = 11  " +
            "AND TPigArchives.FPigClassEnum = 3 THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 )  " +
            "END AS 'shbamount'  " +
            "FROM " +
            "TPigArchives " +
            "LEFT JOIN TPigArchivesChild ON TPigArchivesChild.FPigArchivesMainStruID = TPigArchives.FID  " +
            "WHERE " +
            "TPigArchives.FPigClassEnum IN ( 1, 2, 3 )  " +
            "AND TPigArchives.FBATCHSTATE = 0  " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID, " +
            "TPigArchives.FPIGSTATEE, " +
            "TPigArchives.FPigClassEnum  " +
            ") tblz_tmp  " +
            "GROUP BY " +
            "tblz_tmp.FNAME  " +
            ") AS tbls_tmp ON tbls_tmp.NAME = H.fid  " +
            "ORDER BY " +
            "H.FNAME")
    List<Object[]> getAllStorage_old();

    @Query(nativeQuery = true,value ="SELECT " +
            "H.FNAME AS '猪场'," +
            "mzcl AS '母猪存栏'," +
            "gz + mzcl + jc + shbamount AS '总存栏' " +
            "FROM " +
            "(" +
            "SELECT " +
            "TOrganizeCell.FID," +
            "TOrganizeCell.FName " +
            "FROM " +
            "TOrganizeCell " +
            "GROUP BY " +
            "TOrganizeCell.FName," +
            "TOrganizeCell.FID " +
            ") H " +
            "RIGHT JOIN ( " +
            "SELECT " +
            "tblz_tmp.FNAME AS NAME," +
            "isnull( SUM( tblz_tmp.gz ), 0 ) AS 'gz'," +
            "isnull( sum( tblz_tmp.mzcl ), 0 ) AS 'mzcl'," +
            "isnull( SUM( tblz_tmp.jc ), 0 ) AS 'jc'," +
            "isnull( SUM( tblz_tmp.shbamount ), 0 ) AS 'shbamount' " +
            "FROM " +
            "(" +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME'," +
            "CASE " +
            "WHEN TPigArchives.FPIGSTATEE IN ( 2, 11 ) " +
            "AND TPigArchives.FPigClassEnum = 1 THEN " +
            "COUNT( TPigArchives.FID ) " +
            "END AS 'gz'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 3, 4, 5, 6, 7, 10, 11, 12, 13 ) " +
            "AND TPigArchives.FPigClassEnum = 2 THEN " +
            "COUNT( TPigArchives.FID ) " +
            "END AS 'mzcl'," +
            "0 AS 'jc'," +
            "0 AS 'shbamount' " +
            "FROM " +
            "TPigArchives " +
            "WHERE " +
            "TPigArchives.FPigStatee IN ( 2, 3, 4, 5, 6, 7, 10, 11, 12, 13 ) " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID," +
            "TPigArchives.FPIGSTATEE," +
            "TPigArchives.FPigClassEnum UNION ALL " +
            "SELECT " +
            "TPigArchives.HOGPENWHEREDID 'FNAME'," +
            "0 AS 'gz'," +
            "0 AS 'mzcl'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee IN ( 15, 14, 1, 21, 22, 16 ) THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 ) " +
            "END AS 'jc'," +
            "CASE " +
            "WHEN TPigArchives.FPigStatee = 11 " +
            "AND TPigArchives.FPigClassEnum = 3 THEN " +
            "isnull( SUM( TPigArchivesChild.FpigAmountOfPigsty ), 0 ) " +
            "END AS 'shbamount' " +
            "FROM " +
            "TPigArchives " +
            "LEFT JOIN TPigArchivesChild ON TPigArchivesChild.FPigArchivesMainStruID = TPigArchives.FID " +
            "WHERE " +
            "TPigArchives.FPigClassEnum IN ( 1, 2, 3 ) " +
            "AND TPigArchives.FBATCHSTATE = 0 " +
            "GROUP BY " +
            "TPigArchives.HOGPENWHEREDID," +
            "TPigArchives.FPIGSTATEE," +
            "TPigArchives.FPigClassEnum " +
            ") tblz_tmp " +
            "GROUP BY " +
            "tblz_tmp.FNAME " +
            ") AS tbls_tmp ON tbls_tmp.NAME = H.fid where H.FNAME in(?1) " +
            "ORDER BY " +
            "H.FNAME")
    List<Object[]> getAllStorage(String farmName);

    /**
     * @Method      : getPigletSurvivalRate
     * @Description : 猪仔存活率
     * @Params      : [startDate, endDate, farmName]
     * @Return      : java.util.List<java.lang.Object[]>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/6/30       
     * @Time        : 13:31
     */
    @Query(nativeQuery = true,value = "select \n" +
            " (SELECT  CASE WHEN DATEDIFF ( dd , '2021-02-01' , '2021-03-09' ) >=31  THEN \n" +
            " case when ISNULL(cszrjcl.ZCZS,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/cszrjcl.ZCZS else 0 end ELSE \n" +
            " case when ISNULL(zrjcl.RJAmount,0)!=0 then 1-(isnull(die.教槽,0)+isnull(lose.教槽,0))/zrjcl.RJAmount else 0 end END )AS '仔猪存活率',\n" +
            " TOrganizeCell.FName 'ZCNAME'\n" +
            "from(select tmp_tblcl.ZCID as 'ZCID',sum(tmp_tblcl.ZCL) as 'ZCL',sum(tmp_tblcl.JCMZ) as 'JCMZ',sum(tmp_tblcl.HBMZ) as 'HBMZ',sum(tmp_tblcl.GZ) as 'GZ',sum(tmp_tblcl.HBGZ) as 'HBGZ',sum(tmp_tblcl.BRZZ) as 'BRZZ',sum(tmp_tblcl.BYZ) as 'BYZ',sum(tmp_tblcl.YFZ) as 'YFZ',sum(tmp_tblcl.HBSPZ) as 'HBSPZ' \n" +
            "  from(select TStockHistory.hogpenDID as 'ZCID', sum(TStockHistory.FAmountChangeInt) as 'ZCL', \n" +
            "    case when TStockHistory.FPigStatee in(3,4,5,6,7,10,12,13) and TStockHistory.FPigClassE=2 then sum(TStockHistory.FAmountChangeInt) end as 'JCMZ', \n" +
            "    case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=2 then sum(TStockHistory.FAmountChangeInt) end as 'HBMZ', \n" +
            "    case when TStockHistory.FPigStatee in(2) and TStockHistory.FPigClassE=1 then sum(TStockHistory.FAmountChangeInt) end as 'GZ', \n" +
            "    case when TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=1 then sum(TStockHistory.FAmountChangeInt) end as 'HBGZ', \n" +
            "    case when TStockHistory.FPigStatee in(15) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'BRZZ', \n" +
            "    case when TStockHistory.FPigStatee in(14) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'BYZ', \n" +
            "    case when (TStockHistory.FPigStatee in(1,22,21,16) or TStockHistory.FPigStatee is null) and TStockHistory.FPigClassE in (1,2,3) then sum(TStockHistory.FAmountChangeInt) end as 'YFZ', \n" +
            "    case when  TStockHistory.FPigStatee in(11) and TStockHistory.FPigClassE=3 then sum(TStockHistory.FAmountChangeInt) end as 'HBSPZ' \n" +
            "   from TStockHistory where TStockHistory.FdateChange<='2021-03-09' and TStockHistory.FPigClassE in(1,2,3) \n" +
            "  and (TStockHistory.hogpenDID in('31025DA4-F9E1-46B8-BF38-5F2FA25E9C07'))\n" +
            "  group by TStockHistory.hogpenDID,TStockHistory.FPigStatee,TStockHistory.FPigClassE ) tmp_tblcl group by tmp_tblcl.ZCID\n" +
            "  ) tmp_tblcl \n" +
            "left join ( select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽\n" +
            "  from\n" +
            "  (select TPigDie.PigHouseID  ,\n" +
            "    case when TPigDieChild.FPigState in(15) and TPigDieChild.FPigSex IN(1,2,3) then sum(TPigDieChild.FweakpigdieCount)+sum(TPigDieChild.Fpigdiecount)  end'教槽' \n" +
            "   from TPigDie \n" +
            "    left join TPigDieChild on TPigDieChild.FPigDieMainStruID=TPigDie.FID \n" +
            "   where TPigDie.FBillState in(3,4,6) and TPigDieChild.FPigSex in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "      and TPigDie.PigHouseID in('31025DA4-F9E1-46B8-BF38-5F2FA25E9C07') \n" +
            "   and ( datediff(dd,'2021-02-01', TPigDie.FDieDate)>=0 and datediff(dd,'2021-03-09',TPigDie.FDieDate) <=0) \n" +
            "   group by TPigDieChild.FPigState,TPigDieChild.FPigSex ,TPigDie.PigHouseID  )temp\n" +
            "   group by temp.PigHouseID\n" +
            "   ) die on die.PigHouseID=tmp_tblcl.ZCID \n" +
            "left join (   select temp.PigHouseID,sum(isnull(temp.教槽,0)) as 教槽\n" +
            "  from\n" +
            "  (select TPigLose.PigHouseID,\n" +
            "    case when TPigLoseChild.FPigState in(15) and TPigLoseChild.FSEX IN(1,2,3) then sum(TPigLoseChild.FpigLoseCount)+sum(TPigLoseChild.FweakPigLoseCount)  end'教槽'\n" +
            "   from TPigLose left join TPigLoseChild on TPigLoseChild.FPigLoseMainStruID=TPigLose.FID \n" +
            "   where TPigLose.FBillState in(3,4,6) and TPigLoseChild.FSEX in(1,2,3) and FPIGSTATE in (14,15,1,21,22,11,2,3,7,12,13,5,6,16)\n" +
            "   and TPigLose.PigHouseID in('31025DA4-F9E1-46B8-BF38-5F2FA25E9C07') \n" +
            "    and (datediff(dd,'2021-02-01', TPigLose.Fpiglosedate )>=0 and datediff(dd,'2021-03-09',TPigLose.Fpiglosedate ) <=0) \n" +
            "   group by TPigLoseChild.FPigState,TPigLoseChild.FSEX ,TPigLose.PigHouseID  )temp\n" +
            "   group by temp.PigHouseID\n" +
            "   ) lose on lose.PigHouseID=tmp_tblcl.ZCID \n" +
            "left join (select tmp_zzchl.ZCID as 'ZCID',SUM(tmp_zzchl.zczc ) as 'ZCZS' from \n" +
            "          (select TBorn.HOGPENDID as 'ZCID',count(TBornNewStru.FWAREPIGNOSTR) as 'zczc'\n" +
            "           from TBorn left join TBornNewStru on TBornNewStru.FBornMainStruID = TBorn.FID \n" +
            "                      left join TPigArchives on TPigArchives.FID = TBornNewStru.PIGFIDID\n" +
            "           where TBorn.FLOGSTATEE in (3,4,6) \n" +
            "             and TBorn.HOGPENDID in ('31025DA4-F9E1-46B8-BF38-5F2FA25E9C07') and  datediff(dd,'2021-02-01',TBorn.FDATEBORN)>=0 and datediff(dd,'2021-03-09',TBorn.FDATEBORN) <=0\n" +
            "             group by TBorn.HOGPENDID\n" +
            "             ) tmp_zzchl group by tmp_zzchl.ZCID )cszrjcl on cszrjcl.ZCID=tmp_tblcl.ZCID\n" +
            "left join (select tmp_tbl.ZCID, AVG(tmp_tbl.FAmount) 'RJAmount'\n" +
            " from (select tppa.HogpendID 'ZCID',tppa.FDay 'FDate',SUM(tppa.FAmount) 'FAmount' from TPigStateAmountForGoods tppa where 1=1 \n" +
            "        and tppa.FDay>='2021-02-01'\n" +
            "           and tppa.FDay<='2021-03-09' and FPigState=15\n" +
            "              and tppa.HogpendID in ('31025DA4-F9E1-46B8-BF38-5F2FA25E9C07')\n" +
            "           group by tppa.HogpendID,tppa.FDay) tmp_tbl group by tmp_tbl.ZCID )zrjcl on zrjcl.ZCID=tmp_tblcl.ZCID\n" +
            " left join TOrganizeCell on tmp_tblcl.ZCID=TOrganizeCell.FID\n")
    List<Object[]> getPigletSurvivalRate(String startDate, String endDate, String farmID);
}